//This was all done by me, SpeedyM! ;)
local XSPINCHAR = 0
local FlyHeight = 0
local SpinDuration = 0
local burstrings = 15
local rbrandom = 1

freeslot("sfx_xspin", "sfx_xspin2", "sfx_xspin3")

local function xspinreset(player)
	player.mo.state = S_PLAY_FALL
	XSPINCHAR = 0
	FlyHeight = 0
	SpinDuration = 0
	S_FadeMusic(100, 1*MUSICRATE, player)
	player.normalspeed = skins[player.mo.skin].normalspeed
	if S_SoundPlaying(player.mo, sfx_xspin) or S_SoundPlaying(player.mo, sfx_xspin2) or S_SoundPlaying(player.mo, sfx_xspin3)
		S_StopSoundByID(player.mo, sfx_xspin) 
		S_StopSoundByID(player.mo, sfx_xspin2) 
		S_StopSoundByID(player.mo, sfx_xspin3)
	end
end

addHook("PlayerThink", function(player)
	if player.rings >= burstrings
	and player.mo.skin == "sonic"
	and XSPINCHAR == 17
		player.pflags = $1|PF_THOKKED
		if rbrandom == 1
			S_StartSound(player.mo, sfx_xspin)
		end
		if rbrandom == 2
			S_StartSound(player.mo, sfx_s3kb6)
			S_StartSound(player.mo, sfx_xspin2)
		end
		if rbrandom == 3
			S_StartSound(player.mo, sfx_s3kb6)
			S_StartSound(player.mo, sfx_xspin3)
		end
		P_GivePlayerRings(player, -burstrings)
		if P_IsObjectOnGround(player.mo)
			FlyHeight = 10
		end
		FlyHeight = 0
		XSPINCHAR = 18
	end
	if XSPINCHAR == 18
	and player.mo.skin == "sonic"
		player.mo.state = S_PLAY_SPINDASH
		local DashTrail = P_SpawnGhostMobj(player.mo)
		DashTrail.colorized = true
		DashTrail.color = player.mo.color
		DashTrail.fuse = 10
		DashTrail.blendmode = AST_ADD
		player.mo.momz = FlyHeight*FRACUNIT
		S_FadeMusic(0, 500, player)
		SpinDuration = $ + 1
		player.normalspeed = 100*FRACUNIT
		player.powers[pw_strong] = STR_TWINSPIN|STR_ANIM
		if (player.cmd.buttons & BT_JUMP)
			FlyHeight = $ + 2
		end
		if (player.cmd.buttons & BT_SPIN)
			FlyHeight = $ - 2
		end
		if P_IsObjectOnGround(player.mo)
			xspinreset(player)
		end
	end
	if (player.cmd.buttons & BT_TOSSFLAG)
	and player.mo.skin == "sonic"
	and player.rings >= burstrings
	and not (player.pflags & PF_THOKKED)
		XSPINCHAR = $ + 1
		rbrandom = $ + 1
		if rbrandom >= 4
			rbrandom = 1
		end
		if P_IsObjectOnGround(player.mo)
			S_StartSound(player.mo, sfx_s3k62)
			player.mo.momz = 10*FRACUNIT
			player.mo.state = S_PLAY_ROLL
			player.pflags = $1|PF_JUMPED
		end
		local CHARGSPIN = P_SpawnGhostMobj(player.mo)
		CHARGSPIN.color = SKINCOLOR_WHITE
		CHARGSPIN.blendmode = AST_ADD
		CHARGSPIN.renderflags = CHARGSPIN.renderflags|FF_FULLBRIGHT
	end
	if SpinDuration == 4*TICRATE
		xspinreset(player)
	end
	if XSPINCHAR >= 19
		XSPINCHAR = 17
	end
end)
// Commands Section

COM_AddCommand("xspinrings", function(player, amount)
	local administrator = IsPlayerAdmin(player)
	if (administrator == true or player == server) then
		if not amount then
			CONS_Printf(player, "Type how many rings you need to use the ring burst.")
			return
		end
	end
	if amount and (administrator == true or player == server) then
		burstrings = tonumber(amount)
		CONS_Printf(player, "Ring burst requirement is now set to "..burstrings.." rings.")
	else
		CONS_Printf(player, "Sorry. You must be the server or an admin to do so.")
		return
	end
end)